module Mazinator  
  class Maze
    
    attr_accessor :maze, :start, :exit
    attr_reader :rows, :cols

    # def initialize(rows=10, cols=10, maze_generator=Mazinator::MazeGenerator.new)
    def initialize(rows=10, cols=10, maze=nil)
      @rows = rows
      @cols = cols
      @maze = maze
      @start = maze[0,0]
      @exit = maze[rows-1, cols-1]
    end

    def print
      board = Array.new(@rows*3) { Array.new(@cols*3,'X') }
      @maze.each{ |cell| put_cell_on_board(cell, board) }
      board.each{|row| puts row.join('')}
    end

    private

    def put_cell_on_board(cell, board)
      cell_sign = cell.visited? ? '+' : ' '
      print_cell(board, cell, cell_sign)
    end

    def print_cell(board, cell, cell_sign)
      board_row = cell.row * 3 + 1
      board_col = cell.col * 3 + 1
      board[board_row][board_col] = cell_sign
      board[board_row][board_col-1] = cell_sign unless cell.walls[:left]
      board[board_row][board_col+1] = cell_sign unless cell.walls[:right]
      board[board_row-1][board_col] = cell_sign unless cell.walls[:up] 
      board[board_row+1][board_col] = cell_sign unless cell.walls[:down]
    end

  end
end